rem @echo off

REM converting %APPROOT% first to it's short form

if "%~1"=="" (

	SET APPROOT=C:\PROGRA~1\IBM\edge

) else (
	if EXIST "%~1" (
		set APPROOT=%~s1
	) else (
		echo "Directory does not exist"
		exit 1
	)
)

set MAJORVERSION=8
set MINORVERSION=5
set REVISION=5
set PATCHLEVEL=2
set PATCH_BUILD="FALSE"

REM Changing PATCH_BUILD to false as IM uninstalls the base version of CP before installing the fix pack
if 5 GTR 0 set PATCH_BUILD="FALSE"
if 2 GTR 0 set PATCH_BUILD="FALSE"

if %PATCH_BUILD%=="TRUE" goto:patch_case

FOR /F "tokens=*" %%A IN ('VER') DO SET WinVer=%%A
FOR %%A IN (%WinVer%) DO SET WinVer=%%A
SET WinVer=%WinVer:]=%
SET 4.=Windows NT 4
SET 5.00.=Windows 2000
SET 5.1.=Windows XP
SET 5.2.=Windows Server 2003
SET 6.0.6001=Windows Vista
SET 6.0.6002=Windows Server 2008
SET 6.1.=Windows 7 or Windows Server 2008 R2
FOR /L %%A IN (4,1,6) DO (
	FOR /F "tokens=1,2 delims==" %%B IN ('SET %%A.') DO (
		IF %WinVer% GEQ %%B (
			SET WinVerTxt=%%C
		)
	)
)

rem Locale settings

START /W REGEDIT /E %Temp%.\international.reg "HKEY_CURRENT_USER\Control Panel\International"
FOR /F "tokens=1* delims==" %%A IN ('TYPE %Temp%.\international.reg ^| FIND "Locale"') DO SET Locale=%%B
if /I "%WinVerTxt%"=="Windows 7 or Windows Server 2008 R2" (
	if %Locale% == "de-DE" (
		set lang=de_DE
	) else if %Locale% == "es-ES" (
		set lang=es_ES
	) else if %Locale% == "fr-FR" (
		set lang=fr_FR
	) else if %Locale% == "it-IT" (
		set lang=it_IT
	) else if %Locale% == "ko-KR" (
		set lang=ko_KR
	) else if %Locale% == "ja-JP" (
		set lang=ja_JP
	) else if %Locale% == "pl-PL" (
		set lang=pl_PL
	) else if %Locale% == "cs-CZ" (
		set lang=cs_CZ
	) else if %Locale% == "hu-HU" (
		set lang=hu_HU
	) else if %Locale% == "zh-TW" (
		set lang=zh_TW
	) else if %Locale% == "ru-RU" (
		set lang=ru_RU
	) else if %Locale% == "pt-BR" (
		set lang=pt_BR
	) else if %Locale% == "zh-CN" (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
) else (
	SET Locale=%Locale:"=%
	set /a dec=0x%Locale%
	if "%dec%" == 1031 (
		set lang=de_DE
	) else if "%dec%" == 1034 (
		set lang=es_ES
	) else if "%dec%" == 1036 (
		set lang=fr_FR
	) else if "%dec%" == 1040 (
		set lang=it_IT
	) else if "%dec%" == 1042 (
		set lang=ko_KR
	) else if "%dec%" == 1041 (
		set lang=ja_JP
	) else if "%dec%" == 1045 (
		set lang=pl_PL
	) else if "%dec%" == 1029 (
		set lang=cs_CZ
	) else if "%dec%" == 1038 (
		set lang=hu_HU
	) else if "%dec%" == 1028 (
		set lang=zh_TW
	) else if "%dec%" == 1049 (
		set lang=ru_RU
	) else if "%dec%" == 1046 (
		set lang=pt_BR
	) else if "%dec%" == 2052 (
		set lang=zh_CN
	) else (
		set lang=en_US
	)
)

REM install gskit

chdir ../gskit
gsk8ssl32.exe -s -v"/quiet"
if %ERRORLEVEL% NEQ 0 (
	if %ERRORLEVEL% NEQ 1158 (
		echo "GSKIT installation unsuccessful. Installation will not proceed
		exit %ERRORLEVEL%
	)
)


REM creating cp service

sc create "IBM Caching Proxy" binpath= "%APPROOT%\cp\bin\ibmproxy.exe" type= share DisplayName= "IBM Caching Proxy" start= auto
if %ERRORLEVEL% NEQ 0 exit %ERRORLEVEL%

set key="HKLM\SOFTWARE\IBM\WSES-Admin"
reg add %key% /f

set key=%key%\8
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\admin" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM WSES Administration Platform" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f

set key="HKLM\SOFTWARE\IBM\WSES-Admin\CurrentVersion"
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\admin" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM WSES Administration Platform" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
	
set key="HKLM\SOFTWARE\IBM\WSES-ICU"
reg add %key% /f
set key=%key%\8
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\icu" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM WSES International Component for Unicode" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v ICUVersion /d 1.8 /f

set key="HKLM\SOFTWARE\IBM\WSES-ICU\CurrentVersion"
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\icu" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM WSES International Component for Unicode" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v ICUVersion /d 1.8 /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy"
reg add %key% /f
set key=%key%\8
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\cp" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM Caching Proxy" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v InstalledLangs /d %lang% /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy\8\Components"
reg add %key% /f
reg add %key% /v "Base Component" /f

set key=%key%\Directories
reg add %key% /f
reg add %key% /v ETCpath /d "%APPROOT%\cp\etc" /f
reg add %key% /v Administration /d "%APPROOT%\cp\SERVER~1\Admin" /f
reg add %key% /v "CGI Bin Scripts" /d "%APPROOT%\cp\SERVER~1\CGI-Bin" /f
reg add %key% /v Documentation /d "%APPROOT%\cp\SERVER~1\Docs" /f
reg add %key% /v Executables /d "%APPROOT%\cp\Bin" /f
reg add %key% /v HTML /d "%APPROOT%\cp\SERVER~1\pub\%lang%" /f
reg add %key% /v "Icon and Graphics" /d "%APPROOT%\cp\SERVER~1\cpicons" /f
reg add %key% /v Logs /d "%APPROOT%\cp\SERVER~1\Logs" /f
reg add %key% /v "Main Directory" /d "%APPROOT%\cp" /f
reg add %key% /v Messages /d "%APPROOT%\cp\msg" /f
reg add %key% /v Protect /d "%APPROOT%\cp\SERVER~1\protect" /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy\8\Directories"
reg add %key% /f
reg add %key% /v ETCpath /d "%APPROOT%\cp\etc" /f
reg add %key% /v Administration /d "%APPROOT%\cp\SERVER~1\Admin" /f
reg add %key% /v "CGI Bin Scripts" /d "%APPROOT%\cp\SERVER~1\CGI-Bin" /f
reg add %key% /v Documentation /d "%APPROOT%\cp\SERVER~1\Docs" /f
reg add %key% /v Executables /d "%APPROOT%\cp\Bin" /f
reg add %key% /v HTML /d "%APPROOT%\cp\SERVER~1\pub\%lang%" /f
reg add %key% /v "Icon and Graphics" /d "%APPROOT%\cp\SERVER~1\cpicons" /f
reg add %key% /v Logs /d "%APPROOT%\cp\SERVER~1\Logs" /f
reg add %key% /v "Main Directory" /d "%APPROOT%\cp" /f
reg add %key% /v Messages /d "%APPROOT%\cp\msg" /f
reg add %key% /v Protect /d "%APPROOT%\cp\SERVER~1\protect" /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy\CurrentVersion"
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%\cp" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "IBM Caching Proxy" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v InstalledLangs /d %lang% /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy\CurrentVersion\Directories"
reg add %key% /f
reg add %key% /v ETCpath /d "%APPROOT%\cp\etc" /f
reg add %key% /v Administration /d "%APPROOT%\cp\SERVER~1\Admin" /f
reg add %key% /v "CGI Bin Scripts" /d "%APPROOT%\cp\SERVER~1\CGI-Bin" /f
reg add %key% /v Documentation /d "%APPROOT%\cp\SERVER~1\Docs" /f
reg add %key% /v Executables /d "%APPROOT%\cp\Bin" /f
reg add %key% /v HTML /d "%APPROOT%\cp\SERVER~1\pub\%lang%" /f
reg add %key% /v "Icon and Graphics" /d "%APPROOT%\cp\SERVER~1\cpicons" /f
reg add %key% /v Logs /d "%APPROOT%\cp\SERVER~1\Logs" /f
reg add %key% /v "Main Directory" /d "%APPROOT%\cp" /f
reg add %key% /v Messages /d "%APPROOT%\cp\msg" /f
reg add %key% /v Protect /d "%APPROOT%\cp\SERVER~1\protect" /f

set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy\CurrentVersion\Components"
reg add %key% /f
reg add %key% /v "Base Component" /f

set key=%key%\Directories
reg add %key% /f
reg add %key% /v ETCpath /d "%APPROOT%\cp\etc" /f
reg add %key% /v Administration /d "%APPROOT%\cp\SERVER~1\Admin" /f
reg add %key% /v "CGI Bin Scripts" /d "%APPROOT%\cp\SERVER~1\CGI-Bin" /f
reg add %key% /v Documentation /d "%APPROOT%\cp\SERVER~1\Docs" /f
reg add %key% /v Executables /d "%APPROOT%\cp\Bin" /f
reg add %key% /v HTML /d "%APPROOT%\cp\SERVER~1\pub\%lang%" /f
reg add %key% /v "Icon and Graphics" /d "%APPROOT%\cp\SERVER~1\cpicons" /f
reg add %key% /v Logs /d "%APPROOT%\cp\SERVER~1\Logs" /f
reg add %key% /v "Main Directory" /d "%APPROOT%\cp" /f
reg add %key% /v Messages /d "%APPROOT%\cp\msg" /f
reg add %key% /v Protect /d "%APPROOT%\cp\SERVER~1\protect" /f

set key="HKLM\SOFTWARE\IBM\WSES-Documentation"
reg add %key% /f
set key=%key%\8
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "WSES Documentation" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v InstalledLangs /d %lang% /f

set key="HKLM\SOFTWARE\IBM\WSES-Documentation\CurrentVersion"
reg add %key% /f
reg add %key% /v PathName /d "%APPROOT%" /f
reg add %key% /v Version /d 8.5 /f
reg add %key% /v MajorVersion /t REG_DWORD /d 0x8 /f
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v Description /d "WSES Documentation" /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
reg add %key% /v InstalledLangs /d %lang% /f
	
set key="HKLM\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\ibmproxy.exe"
reg add %key% /f
reg add %key% /v Path /d "%APPROOT%\cp\bin" /f
reg add %key% /ve /d "%APPROOT%\cp\bin\ibmproxy.exe" /f 

REM adding keys in case winNT
REM replacing reg keys wit hsc command. if that will not work, it will need to be replaced again.

if "%WinVerTxt%"=="Windows NT 4" (
	sc create "IbmIcsPerf" binpath= "%APPROOT%\cp\bin\icsperfm.dll" type= share DisplayName= "IbmIcsPerf"
	if %ERRORLEVEL% NEQ 0 exit %ERRORLEVEL%
)

set NEWPATH="%PATH%;%APPROOT%\icu\lib;%APPROOT%\admin\platform\bin;%APPROOT%\cp\Bin;%APPROOT%\cp\lib\plugins\pac;C:\PROGRA~1\IBM\gsk8\bin;C:\PROGRA~1\IBM\gsk8\lib;C:\PROGRA~2\IBM\gsk8\bin;C:\PROGRA~2\IBM\gsk8\lib"
set NLSPATH=%APPROOT%\cp\msg\%lang%\%%N;%APPROOT%\cp\server_root\admin-bin\%lang%\%%N
set key="HKLM\SYSTEM\ControlSet001\Control\Session Manager\Environment"

reg add %key% /v NLSPATH /t REG_EXPAND_SZ /d %NLSPATH% /f

REM notice that - overwriting PATH with no prompt !
reg add %key% /v PATH /t REG_EXPAND_SZ /d %NEWPATH% /f 

set key="HKLM\SYSTEM\CurrentControlSet\Control\Session Manager\Environment"

reg add %key% /v NLSPATH /t REG_EXPAND_SZ /d %NLSPATH% /f

REM notice that - overwriting PATH with no prompt !
reg add %key% /v PATH /t REG_EXPAND_SZ /d %NEWPATH% /f 

if "%WinVerTxt%"=="Windows NT 4" (
	%SYSTEMROOT%\System32\lodctr.exe %APPROOT%\cp\binicsperfm.ini
	
	echo Set oWS = WScript.CreateObject("WScript.Shell") > %TEMP%\sc_create.vbs
	echo sLinkFile = "%SYSTEMROOT%\inf\009\IbmIcsPerf\icsperfm.ini.LNK" >> %TEMP%\sc_create.vbs
	echo Set oLink = oWS.CreateShortcut(sLinkFile) >> %TEMP%\sc_create.vbs
	echo oLink.TargetPath = "%APPROOT%\cp\bin\icsperfm.ini" >> %TEMP%\sc_create.vbs
	REM echo oLink.Arguments = "%APPROOT%\cp" >> %TEMP%\sc_create.vbs
	echo oLink.Description = icsperfm.ini >> %TEMP%\sc_create.vbs
	REM echo 'oLink.HotKey = "ALT+CTRL+F" >> %TEMP%\sc_create.vbs
	echo oLink.IconLocation = "%APPROOT%\cp\bin\icsperfm.ini, 2" >> %TEMP%\sc_create.vbs
	REM REM echo 'oLink.WindowStyle = "1" >> %TEMP%\sc_create.vbs
	echo oLink.WorkingDirectory = "%SYSTEMROOT%\inf\009\IbmIcsPerf" >> %TEMP%\sc_create.vbs
	echo oLink.Save >> %TEMP%\sc_create.vbs
	
	cscript /B %TEMP%\sc_create.vbs
		
	echo Set oWS = WScript.CreateObject("WScript.Shell") > %TEMP%\sc_create.vbs
	echo sLinkFile = "%SYSTEMROOT%\inf\inc\IbmIcsPerf\icsperfm.h.LNK" >> %TEMP%\sc_create.vbs
	echo Set oLink = oWS.CreateShortcut(sLinkFile) >> %TEMP%\sc_create.vbs
	echo oLink.TargetPath = "%APPROOT%\cp\bin\icsperfm.h" >> %TEMP%\sc_create.vbs
	REM echo oLink.Arguments = "%APPROOT%\cp" >> %TEMP%\sc_create.vbs
	echo oLink.Description = icsperfm.h >> %TEMP%\sc_create.vbs
	REM echo 'oLink.HotKey = "ALT+CTRL+F" >> %TEMP%\sc_create.vbs
	echo oLink.IconLocation = "%APPROOT%\cp\bin\icsperfm.h, 2" >> %TEMP%\sc_create.vbs
	REM REM echo 'oLink.WindowStyle = "1" >> %TEMP%\sc_create.vbs
	echo oLink.WorkingDirectory = "%SYSTEMROOT%\inf\inc\IbmIcsPerf" >> %TEMP%\sc_create.vbs
	echo oLink.Save >> %TEMP%\sc_create.vbs
	
	cscript /B %TEMP%\sc_create.vbs
)

REM Restore the configuration files you backed up before.I have changed the pre script as well a bit for the protect dir.

if EXIST %APPROOT%\oldfiles\ibmproxy.conf xcopy /Y/I %APPROOT%\oldfiles\ibmproxy.conf %APPROOT%\cp\etc\%lang%
if EXIST %APPROOT%\oldfiles\rca.conf xcopy /Y/I %APPROOT%\oldfiles\rca.conf %APPROOT%\cp\etc\%lang%
if EXIST %APPROOT%\oldfiles\socks.conf.exp xcopy /Y/I %APPROOT%\oldfiles\socks.conf.exp %APPROOT%\cp\etc\%lang%
if EXIST %APPROOT%\oldfiles\pac.conf xcopy /Y/I %APPROOT%\oldfiles\pac.conf %APPROOT%\cp\etc\%lang% 
if EXIST %APPROOT%\oldfiles\paccp.conf xcopy %APPROOT%\oldfiles\paccp.conf /Y/I %APPROOT%\cp\etc\%lang% 
if EXIST %APPROOT%\oldfiles\pacpolicy.conf xcopy %APPROOT%\oldfiles\pacpolicy.conf /Y/I %APPROOT%\cp\etc\%lang% 

if EXIST %APPROOT%\oldfiles\protect xcopy /Y/I/E/H %APPROOT%\oldfiles\protect\* %APPROOT%\cp\server_root\protect 

REM Find and replace "C:\PROGRA~1\IBM\edge" in ibmproxy.conf with %APPROOT%
	
echo Const ForReading = 1  > %TEMP%\find_replace.vbs  
echo Const ForWriting = 2  >> %TEMP%\find_replace.vbs
echo strFileName = Wscript.Arguments(0) >> %TEMP%\find_replace.vbs
echo strOldText = Wscript.Arguments(1) >> %TEMP%\find_replace.vbs 
echo strNewText = Wscript.Arguments(2) >> %TEMP%\find_replace.vbs 
echo Set objFSO = CreateObject("Scripting.FileSystemObject") >> %TEMP%\find_replace.vbs
echo Set objFile = objFSO.OpenTextFile(strFileName, ForReading) >> %TEMP%\find_replace.vbs
echo strText = objFile.ReadAll >> %TEMP%\find_replace.vbs
echo objFile.Close >> %TEMP%\find_replace.vbs
echo strNewText = Replace(strText, strOldText, strNewText) >> %TEMP%\find_replace.vbs
echo Set objFile = objFSO.OpenTextFile(strFileName, ForWriting) >> %TEMP%\find_replace.vbs
echo objFile.WriteLine strNewText >> %TEMP%\find_replace.vbs
echo objFile.Close >> %TEMP%\find_replace.vbs


cscript /B %TEMP%\find_replace.vbs %APPROOT%\cp\etc\%lang%\ibmproxy.conf C:\PROGRA~1\IBM\edge %APPROOT%
cscript /B %TEMP%\find_replace.vbs %APPROOT%\cp\etc\%lang%\ibmproxy.conf C:\Progra~1\IBM\edge %APPROOT%

del /Q %TEMP%\sc_create.vbs
del /Q %TEMP%\find_replace.vbs
	
:patch_case

echo updating installed software versions

set key="HKLM\SOFTWARE\IBM\WSES-Admin\CurrentVersion"
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f

set key="HKLM\SOFTWARE\IBM\WSES-ICU"
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
	
set key="HKLM\SOFTWARE\IBM\WSES-ICU\CurrentVersion"
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f
	
set key="HKLM\SOFTWARE\IBM\WSES-Caching Proxy"
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f

set key="HKLM\SOFTWARE\IBM\WSES-Documentation"
reg add %key% /v MinorVersion /t REG_DWORD /d 5 /f
reg add %key% /v Revision /t REG_DWORD /d 5 /f
reg add %key% /v PatchLevel /t REG_DWORD /d 2 /f

GOTO:EOF
